﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using FlashCard7BL;
using FlashCard7BL.Interficies;

namespace FlashCard7
{
    class BLClientProxy : ClientBase<IBL>, IBL
    {
        public Paquet GetPaquet(string paquetId)
        {
            return this.Channel.GetPaquet(paquetId);
        }

        public Rol GetRol(string rolId)
        {
            return this.Channel.GetRol(rolId);
        }

        public Usuari LoginUsuari(string sLogin, string sContrasenya)
        {
            return this.Channel.LoginUsuari(sLogin, sContrasenya);
        }

        public List<Usuari> GetUsuaris()
        {
            return this.Channel.GetUsuaris();
        }

        public List<Tematica> GetTematiques()
        {
            return this.Channel.GetTematiques();
        }

        public bool InsertDirectTargeta(Targeta t)
        {
            return this.Channel.InsertDirectTargeta(t);
        }

        public bool InsertTargeta(string titolF, string descF, string titolB, string descB, string idPaquet)
        {
            return this.Channel.InsertTargeta(titolF, descF, titolB, descB, idPaquet);
        }

        public bool ActualitzaCredit(decimal dCredit, int idUsuari)
        {
            return this.Channel.ActualitzaCredit(dCredit, idUsuari);
        }

        public bool CodiUtilitzat(int idCodi)
        {
            return this.Channel.CodiUtilitzat(idCodi);
        }

        public Codis ComprovaValidaCodi(string sCodi)
        {
            return this.Channel.ComprovaValidaCodi(sCodi);
        }

        public Usuari GetUsuari(int idUsuari)
        {
            return this.Channel.GetUsuari(idUsuari);
        }

        public bool ComprarPaquet(int idUsuari, int idPaquet)
        {
            return this.Channel.ComprarPaquet(idUsuari, idPaquet);
        }

        public bool ComprovaUsuariPaquet(int idUsuari, int idPaquet)
        {
            return this.Channel.ComprovaUsuariPaquet(idUsuari, idPaquet);
        }

        public List<Rol> GetRols()
        {
            return this.Channel.GetRols();
        }

        public bool InsertOrEditUsuari(Usuari usuari)
        {
            return this.Channel.InsertOrEditUsuari(usuari);
        }

        public bool DeleteUsuari(int idUsuari)
        {
            return this.Channel.DeleteUsuari(idUsuari);
        }
    }
}
