﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using FlashCard7BL;
using FlashCard7BL.Interficies;

namespace FlashCard7
{
    /// <summary>
    /// Interaction logic for FlashCardSystemControl.xaml
    /// </summary>
    public partial class FlashCardSystemControl : UserControl
    {

        private Paquet _oPaquet;
        private int index;

        public Paquet oPaquet
        {
            get { return _oPaquet; }
            set { _oPaquet = value; }
        }

        public FlashCardSystemControl()
        {
            InitializeComponent();

            tCtrlCentral.btnTargeta.Click += new RoutedEventHandler(btnTargetaCentral_Click);
            tCtrlEsquerra.btnTargeta.Click += new RoutedEventHandler(btnTargetaEsquerra_Click);
            tCtrlDreta.btnTargeta.Click += new RoutedEventHandler(btnTargetaDreta_Click);
        }

        public void CarregaPaquet(Paquet p)
        {
            this.oPaquet = p;
            this.index = 0;
            this.CarregaTargetes();
            this.ActualitzaContador();
            this.txbTematica.Text = this.oPaquet.Nom;
        }

        void btnTargetaDreta_Click(object sender, RoutedEventArgs e)
        {
            if (this.index != this.oPaquet.Targetes.Count + 1)
            {
                this.index++;
            }
            this.ActualitzaContador();
            this.CarregaTargetes();
        }

        void btnTargetaEsquerra_Click(object sender, RoutedEventArgs e)
        {
            if (this.index != 0)
            {
                this.index--;
            }
            this.ActualitzaContador();
            this.CarregaTargetes();
        }

        void btnTargetaCentral_Click(object sender, RoutedEventArgs e)
        {
            tCtrlCentral.Gira();
        }

        private void CarregaTargetes()
        {
            if (this.oPaquet.Targetes.Count > 0)
            {
                tCtrlCentral.Carrega(this.oPaquet.Targetes[index]);
                if (this.index != 0)
                {
                    tCtrlEsquerra.Carrega(this.oPaquet.Targetes[index - 1]);
                }
                else
                {
                    tCtrlEsquerra.Carrega(null);
                }
                if (this.oPaquet.Targetes.Count > index + 1)
                {
                    tCtrlDreta.Carrega(this.oPaquet.Targetes[index + 1]);
                }
                else
                {
                    tCtrlDreta.Carrega(null);
                }
            }
            else
            {
                tCtrlEsquerra.Carrega(null);
                tCtrlDreta.Carrega(null);
                tCtrlCentral.Carrega(null);
            }
        }

        private void ActualitzaContador()
        {
            if (this.oPaquet.Targetes.Count > 0)
            {
                this.txbTotalTargetes.Text = (this.index + 1).ToString() + "/" + this.oPaquet.Targetes.Count.ToString();
            }
            else
            {
                this.txbTotalTargetes.Text = "0";
            }
        }
    }
}
