﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using FlashCard7BL;
using FlashCard7BL.Interficies;

namespace FlashCard7
{
    /// <summary>
    /// Interaction logic for UsersManagementControl.xaml
    /// </summary>
    public partial class UsersManagementControl : UserControl
    {
        BLClientProxy proxy = new BLClientProxy();

        private Usuari _usuariActual;

        private Usuari UsuariActual
        {
            get
            {
                this._usuariActual = null;
                if (gridUsuaris.SelectedItem is Usuari)
                {
                    this._usuariActual = (Usuari)gridUsuaris.SelectedItem;
                }                    
                return this._usuariActual;
            }
        }

        public UsersManagementControl()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            this.CarregaGrid();
        }

        private void CarregaGrid()
        {
            gridUsuaris.AutoGenerateColumns = false;
            gridUsuaris.ItemsSource = proxy.GetUsuaris();
        }

        private void btnAfegirUsuari_Click(object sender, RoutedEventArgs e)
        {
            UsersManagementWindow umw = new UsersManagementWindow();
            umw.UsuariEditant = new Usuari();
            umw.ShowDialog();
            if (umw.DialogResult.HasValue)
            {
                if (umw.DialogResult.Value)
                {
                    CarregaGrid();
                }
            }
        }

        private void btnEditarUsuari_Click(object sender, RoutedEventArgs e)
        {
            if (this.UsuariActual != null)
            {
                UsersManagementWindow umw = new UsersManagementWindow();
                umw.UsuariEditant = this.UsuariActual;
                umw.ShowDialog();
                if (umw.DialogResult.HasValue)
                {
                    if (umw.DialogResult.Value)
                    {
                        CarregaGrid();
                    }
                }
            }
        }

        private void btnEliminarUsuari_Click(object sender, RoutedEventArgs e)
        {
            if (this.UsuariActual != null)
            {
                if (this.UsuariActual.Id != VariablesGlobals.UsuariActual.Id)
                {
                    if (MessageBox.Show(this.UsuariActual.Nom + Properties.Resources.rxUsuariSeraEliminat, Properties.Resources.rxAvis, MessageBoxButton.YesNo, MessageBoxImage.Question)
                        == MessageBoxResult.Yes)
                    {
                        if (proxy.DeleteUsuari(this.UsuariActual.Id))
                        {
                            MessageBox.Show(Properties.Resources.rxUsuariEliminat, Properties.Resources.rxAvis, MessageBoxButton.OK, MessageBoxImage.Information);
                            CarregaGrid();
                        }
                        else
                        {
                            MessageBox.Show(Properties.Resources.rxSistemaCaigut, Properties.Resources.rxAvis, MessageBoxButton.OK, MessageBoxImage.Warning);
                        }
                    }
                }
                else
                {
                    MessageBox.Show(Properties.Resources.rxNoPotsEliminarUsuari, Properties.Resources.rxAvis, MessageBoxButton.OK, MessageBoxImage.Warning);
                }
            }
        }

    }
}
