﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using FlashCard7BL;
using FlashCard7BL.Interficies;

namespace FlashCard7
{
    /// <summary>
    /// Interaction logic for PaquetMercatControl.xaml
    /// </summary>
    public partial class PaquetMercatControl : UserControl
    {

        private Paquet _paq;

        public Paquet Paq
        {
            get { return _paq; }
            set { _paq = value; }
        }

        private BLClientProxy proxy = new BLClientProxy();

        public PaquetMercatControl()
        {
            InitializeComponent();
        }

        public void CarregaPaquet(Paquet p)
        {
            this.Paq = p;
            this.lblNomPaquet.Content = p.Nom;
            this.lblPreu.Content = string.Format("{0:0.00}", p.Preu) + Properties.Resources.rxMoneda;
            this.lblNomPaquet.ToolTip = p.Descripcio;
        }

        private void btnCompra_Click(object sender, RoutedEventArgs e)
        {
            if (!proxy.ComprovaUsuariPaquet(VariablesGlobals.UsuariActual.Id, this.Paq.Id))
            {
                if (VariablesGlobals.UsuariActual.Credit >= this.Paq.Preu)
                {
                    if (proxy.ComprarPaquet(VariablesGlobals.UsuariActual.Id, this.Paq.Id))
                    {
                        VariablesGlobals.ResetUsuari();
                        VariablesGlobals.MainFinestra.ActualitzaInfoUsuari();
                        MessageBox.Show(Properties.Resources.rxCompraPaquet + this.Paq.Nom, Properties.Resources.rxCompraRealitzada, MessageBoxButton.OK, MessageBoxImage.Information);

                    }
                    else
                    {
                        MessageBox.Show(Properties.Resources.rxSistemaCaigut, Properties.Resources.rxAvis, MessageBoxButton.OK, MessageBoxImage.Information);
                    }
                }
                else
                {
                    MessageBox.Show(Properties.Resources.rxSenseDiners + Environment.NewLine + Properties.Resources.rxObreCredit, Properties.Resources.rxAvis, MessageBoxButton.OK, MessageBoxImage.Information);
                }
            }
            else
            {
                MessageBox.Show(Properties.Resources.rxPaquetJaComprat, Properties.Resources.rxAvis, MessageBoxButton.OK, MessageBoxImage.Information);
            }
        }
    }
}
