﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using FlashCard7;
using FlashCard7BL.Interficies;

namespace FlashCard7
{
    /// <summary>
    /// Interaction logic for CreditWindow.xaml
    /// </summary>
    public partial class CreditWindow : Window
    {
        BLClientProxy proxy = new BLClientProxy();

        public CreditWindow()
        {
            InitializeComponent();
        }

        private void btnCancel_Click(object sender, RoutedEventArgs e)
        {
            this.txbResultatCodi.Visibility = System.Windows.Visibility.Hidden;
            this.Close();
        }

        private void txtCode1_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (txtCode1.Text.Length >= 5)
            {
                txtCode2.Focus();
            }
        }

        private void txtCode2_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (txtCode2.Text.Length >= 5)
            {
                txtCode3.Focus();
            }
        }

        private void txtCode3_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (txtCode3.Text.Length >= 5)
            {
                txtCode4.Focus();
            }
        }

        private void txtCode4_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (txtCode4.Text.Length >= 5)
            {
                txtCode5.Focus();
            }
        }

        private void NetejaCodi()
        {
            txtCode1.Text = string.Empty;
            txtCode2.Text = string.Empty;
            txtCode3.Text = string.Empty;
            txtCode4.Text = string.Empty;
            txtCode5.Text = string.Empty;
            txtCode1.Focus();
        }

        private void btnAddCredit_Click(object sender, RoutedEventArgs e)
        {
            this.txbResultatCodi.Visibility = System.Windows.Visibility.Hidden;

            string sCodi = string.Empty;

            sCodi = txtCode1.Text + txtCode2.Text + txtCode3.Text + txtCode4.Text + txtCode5.Text;

            sCodi = sCodi.ToUpper();

            if (sCodi.Length != 25)
            {
                txbResultatCodi.Foreground = new SolidColorBrush(Colors.Red);
                txbResultatCodi.Text = Properties.Resources.rxCodiIncomplet;
                this.txbResultatCodi.Visibility = System.Windows.Visibility.Visible;
            }
            else
            {
                Codis codi = proxy.ComprovaValidaCodi(sCodi);
                if (codi!=null)
                {
                    if (!codi.Utilitzat)
                    {
                        if(proxy.ActualitzaCredit(codi.Valor, VariablesGlobals.UsuariActual.Id))
                        {
                            VariablesGlobals.ResetUsuari();
                            if (VariablesGlobals.MainFinestra.ActualitzaInfoUsuari())
                            {
                                txbResultatCodi.Foreground = new SolidColorBrush(Colors.Green);
                                txbResultatCodi.Text = Properties.Resources.rxCodiValid;
                                this.txbResultatCodi.Visibility = System.Windows.Visibility.Visible;
                                proxy.CodiUtilitzat(codi.Id);
                            }
                            else
                            {
                                txbResultatCodi.Foreground = new SolidColorBrush(Colors.Red);
                                txbResultatCodi.Text = Properties.Resources.rxSistemaCaigut;
                                this.txbResultatCodi.Visibility = System.Windows.Visibility.Visible;
                            }
                        }
                    }
                    else
                    {
                        txbResultatCodi.Foreground = new SolidColorBrush(Colors.Red);
                        txbResultatCodi.Text = Properties.Resources.rxCodiUtilitzat;
                        this.txbResultatCodi.Visibility = System.Windows.Visibility.Visible;
                    }
                }
                else
                {
                    txbResultatCodi.Foreground = new SolidColorBrush(Colors.Red);
                    txbResultatCodi.Text = Properties.Resources.rxCodiIncorrecte;
                    this.txbResultatCodi.Visibility = System.Windows.Visibility.Visible;
                }
            }

            this.NetejaCodi();
            this.ActualitzaCreditEnPantalla();

        }

        private void ActualitzaCreditEnPantalla()
        {
            this.txbCreditAvailable.Text = string.Format("{0:0.00}", VariablesGlobals.UsuariActual.Credit) + Properties.Resources.rxMoneda;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.ActualitzaCreditEnPantalla();
            this.NetejaCodi();
        }
    }
}
