﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace FlashCard7BL.Interficies
{
    [ServiceContract]
    public interface IBL
    {
        [OperationContract]
        [WebGet(UriTemplate = "/paquet/{paquetId}")]
        Paquet GetPaquet(string paquetId);

        [OperationContract]
        [WebGet(UriTemplate = "/rol/{rolId}")]
        Rol GetRol(string rolId);

        [OperationContract]
        [WebGet(UriTemplate = "/rols")]
        List<Rol> GetRols();

        [OperationContract]
        [WebGet(UriTemplate = "/login/{sLogin}/{sContrasenya}")]
        Usuari LoginUsuari(string sLogin, string sContrasenya);

        [OperationContract]
        Usuari GetUsuari(int idUsuari);

        [OperationContract]
        [WebGet(UriTemplate = "/usuaris")]
        List<Usuari> GetUsuaris();

        [OperationContract]
        [WebGet(UriTemplate = "/tematiques")]
        List<Tematica> GetTematiques();

        [OperationContract]
        [WebGet(UriTemplate = "/inPaquet/{titolF}/{descF}/{titolB}/{descB}/{idPaquet}")]
        bool InsertTargeta(string titolF, string descF, string titolB, string descB, string idPaquet);

        [OperationContract]
        bool InsertDirectTargeta(Targeta t);

        [OperationContract]
        [WebGet(UriTemplate="/validaCodi/{sCodi}")]
        Codis ComprovaValidaCodi(string sCodi);

        [OperationContract]
        [WebInvoke(BodyStyle = WebMessageBodyStyle.WrappedRequest)]
        bool ActualitzaCredit(decimal dCredit, int idUsuari);

        [OperationContract]
        bool CodiUtilitzat(int idCodi);

        [OperationContract]
        [WebInvoke(BodyStyle = WebMessageBodyStyle.WrappedRequest)]
        bool ComprarPaquet(int idUsuari, int idPaquet);

        [OperationContract]
        [WebInvoke(BodyStyle = WebMessageBodyStyle.WrappedRequest)]
        bool ComprovaUsuariPaquet(int idUsuari, int idPaquet);

        [OperationContract]
        bool InsertOrEditUsuari(Usuari usuari);

        [OperationContract]
        bool DeleteUsuari(int idUsuari);
    }
}
