﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

namespace FlashCard7BL_DAL
{
    [ServiceContract]
    public interface iDAL
    {

        [OperationContract]
        Paquet GetPaquet(int idPaquet);

        [OperationContract]
        Rol GetRol(int idRol);

        [OperationContract]
        List<Rol> GetRols();

        [OperationContract]
        Usuari GetUsuari(int idUsuari);

        [OperationContract]
        List<Usuari> GetUsuaris();

        [OperationContract]
        Usuari LoginUsuari(string sLogin, string sContrasenya);

        [OperationContract]
        List<Tematica> GetTematiques();

        [OperationContract]
        bool InsertTargeta(string titolF, string descF, string titolB, string descB, string idPaquet);

        [OperationContract]
        bool InsertDirectTargeta(Targeta t);

        [OperationContract]
        Codi ComprovaValidaCodi(string sCodi);

        [OperationContract]
        bool ActualitzaCredit(decimal dCredit, int idUsuari);

        [OperationContract]
        bool CodiUtilitzat(int idCodi);

        [OperationContract]
        bool ComprarPaquet(int idUsuari, int idPaquet);

        [OperationContract]
        bool ComprovaUsuariPaquet(int idUsuari, int idPaquet);

    }


    [DataContract]
    public class CompositeType
    {
        bool boolValue = true;
        string stringValue = "Hello ";

        [DataMember]
        public bool BoolValue
        {
            get { return boolValue; }
            set { boolValue = value; }
        }

        [DataMember]
        public string StringValue
        {
            get { return stringValue; }
            set { stringValue = value; }
        }
    }
}
